%% Analysis of Notch circuit. 
Fc=900e6;       % center freq
C34= 12e-12;    % creates a Rx passband above the notch.

% tunable notch
Ln=25e-9;    % notch L
Cn=1/(Ln*(2*pi*Fc)^2); % ideal notch C 
Qn = 150;              % finite Q
Rn= 2*pi*Fc*Ln/Qn;

h_c34 = rfckt.shuntrlc('C', C34,'R',inf,'L',inf);
h_l1  = rfckt.shuntrlc('C', 0,'R',inf,'L',Ln);
h_r1  = rfckt.shuntrlc('C', 0,'R',Rn,'L',inf);
h_c2  = rfckt.shuntrlc('C', Cn,'R',inf,'L',inf);
h_notch = rfckt.series('Ckts', {h_l1,h_c2,h_r1});
h_network=rfckt.cascade('Ckts',{h_c34,h_notch})


analyze(h_network,((Fc-20e6):0.2e6:(Fc+180e6)));

subplot(2,1,1),plot(h_network,'S21','S11'); 
subplot(2,1,2), plot(h_network,'S21','S11','Angle');


