% Analyze_Speaker  
% Use with speaker_6x.mdl
L =length(Fvec)/2;
Fmax = Fvec(L);

switch Mode
    case 1
       % Invert Admittance measurement to get Impedance 
       subplot(2,1,1); 
       semilogx(Fvec(1:L),abs(1./TF_meas(1:L))); 
       axis([10 Fmax 0 35])
       xlabel('Hz'); ylabel('Ohms') 
       title('Speaker Impedance (abs(Z))') 
       subplot(2,1,2); 
       semilogx(Fvec(1:L),(180/pi)*angle(1./TF_meas(1:L))); 
       axis([10 Fmax -60 95])
       xlabel('Hz'); ylabel('Degrees') 
       title('Speaker Impedance Phase') 
    case 2 
       % Driving Force vs Vin 
       subplot(2,1,1); 
       semilogx(Fvec(1:L),abs(TF_meas(1:L))); 
       axis([10 Fmax 0 5])
       xlabel('Hz'); ylabel('Driving Force Newtons') 
       title('Speaker Driving Force (abs(F))') 
       subplot(2,1,2); 
       semilogx(Fvec(1:L),(180/pi)*angle(TF_meas(1:L))); 
       axis([10 Fmax -200 200])
       xlabel('Hz'); ylabel('Degrees') 
       title('Speaker Driving Force Phase') 
       
    case 3
      % Velocity vs Vin
       subplot(2,1,1); 
       semilogx(Fvec(1:L),abs(TF_meas(1:L))); 
       axis([10 Fmax 0 .25])
       xlabel('Hz'); ylabel('Velocity m/s') 
       title('Speaker Velocity (abs(v))') 
       subplot(2,1,2); 
       semilogx(Fvec(1:L),(180/pi)*angle(TF_meas(1:L))); 
       axis([10 Fmax -200 200])
       xlabel('Hz'); ylabel('Degrees') 
       title('Speaker Velocity Phase') 
    case 4
      % Acceleration  vs Vin 
       subplot(2,1,1); 
       semilogx(Fvec(1:L),20*log10(abs(TF_meas(1:L)))); 
       axis([10 Fmax 0 50])
       xlabel('Hz'); ylabel('Acceleration dB m/s^2') 
       title('Speaker Acceleration in dB') 
       subplot(2,1,2); 
       semilogx(Fvec(1:L),(180/pi)*angle(TF_meas(1:L))); 
       axis([10 Fmax -90 180])
       xlabel('Hz'); ylabel('Degrees') 
       title('Speaker Acceleration Phase') 
       
   case 5
      % Acceleration  vs Vin  (low freq)
       subplot(2,1,1); 
       semilogx(Fvec(1:L),20*log10(abs(TF_meas(1:L)))); 
       axis([1 Fmax 0 50])
       xlabel('Hz'); ylabel('Acceleration dB m/s^2') 
       title('Speaker Acceleration in dB') 
       subplot(2,1,2); 
       semilogx(Fvec(1:L),(180/pi)*angle(TF_meas(1:L))); 
       axis([1 Fmax -90 180])
       xlabel('Hz'); ylabel('Degrees') 
       title('Speaker Acceleration Phase') 
       
       
end



