%% Fit a ratio of polynomials in the Laplace variable s to transfer function measurement data                                                                                                    
% Dick Benson
close all force
sp = 5; % Start point for plot and fit to discard DC  
% TF is the measured plant transfer function from the simulation 
L=length(Fvec);
f=Fvec(sp:L/2);      % frequency vector 
xfer = TF_meas(sp:L/2); % transfer function
w=2*pi*f;
L=length(f);   
iter=10;
[num,den]=invfreqs(xfer,w,2,3,[],iter); % invfreqs is in the signal processing TB
resp = freqs(num,den,w);                % freq response of fit results                                                                                                                                          
%% plot fit result and the measured transfer function for a check on the fit                                                                                                                                          
subplot(2,1,1);                                                                                                                                        
plot(f,db(resp),f,20*log10(abs(xfer)));
title('Magnitude vs Freq'); xlabel('Hz'); ylabel('dB');legend('fit','meas');             
subplot(2,1,2);                                                                                                                                        
plot(f,(180/pi)*angle(resp),f,(180/pi)*angle(xfer));
title('Phase vs Freq'); xlabel('Hz'); ylabel('Degrees');legend('fit','meas');

%% create an LTI "object" for SISOTool plant model "G"

G=tf(num,den); 
ltiview('step',G);
ltiview('pzmap',G);
save speaker_model G xfer f;  
clc
 