clear all;
clc;

% From  speaker_SS_6b.slx model initfcn callback
% Table 10.1 pp 167
% MKS units
Re =  3.36;          % ohms *
Le = 0.274e-3;       % henries *
Bl = 4.9;            %  Newtons/Amp *
mm = 14.7e-3;        % kg  *
cm = 0.56e-3;        % m/N  *
rm = 0.784;          % kg/s  *
% *= indicates that this value was incorporated in the following script.
% search (rab) for changes from the original

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% User Input Section %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


Mm = mm;                    		    % (rab) Moving mass (kg)
Mmoffset = 0;                           % moving mass offset
Re= Re;                                 % (rab) DC resistance (Ohm)
Bloffset = 0;                           %  BL offset
Vb = 2.558;                             % 8 CF = 0.2265 m3 roof pit, set to 1e9 for free air
ro = 1.2;								% Air density kg/(m^3)
c = 343;								% Sound velocity	(m/sec)
Deff = .402;							% Loudspeaker efficient diameter (meters)  
Seff = pi*(Deff/2.0)^2;				    % Loudspekaer efficient area (m^2)
Kmb = ((ro*c^2)*(Seff^2))/Vb;           % stiffness of test box

% (rab) not used in nonlinear_speaker_2 and 3
Vrms = .01;                             % (rab) RMS Input voltage
inputamplitude = Vrms*sqrt(2);		    % Input voltage (V, amplitude)
inputfrequency = 200;                   % (rab) input frequency




%%


%  Loudspeaker nonlinear parameters %%%%
% Bl-product:
Bcond = 1;                          % Flag of linear and nonlinear Bl-product  
		%b0 = 20.148;                % BL enter as-is from Klippel
        b0 = Bl;                     % (rab)
	 if Bcond == 1
		b1 = 0.07461*1e3;           % Enter number * e3 from Klippel
		b2 = -0.014238*1e6;         % Enter number * e6 from Klippel
		b3 = 0.0022593*1e9;         % Enter number * e9 from Klippel
		b4 = -0.00034589*1e12;      % etc...
		b5 = -1.23E-05*1e15;
		b6 = 1.34E-06*1e18;
		b7 = 1.36E-08*1e21;
		b8 = -1.78E-09*1e24;
	else
		b1 = 0.0;
		b2 = 0.0;
		b3 = 0.0;
		b4 = 0.0;
		b5 = 0.0;
		b6 = 0.0;
		b7 = 0.0;
		b8 = 0.0;
 	end  
 
% Stiffness (assumes Newtons / Meter) :	

Kcond = 1;                          % Flag of linear and nonlinear stiffness	
		k0 = 6.13*1000 + Kmb;       % Enter Klippel N/mm * 1e3 (Kmb adds the test box stiffness)
	if Kcond == 1
		k1 = 0.0085281*1e6;         % Enter Klippel value * 1e6
		k2 = 0.022182*1e9;          % Enter Klippel value * 1e9
		k3 = 0.00021212*1e12;       % Enter Klippel value * 1e12
		k4 = 2.56E-05*1e15;         % Enter Klippel value * 1e15
		k5 = 0.0;                   % etc...
		k6 = 0.0;
		k7 = 0.0;
		k8 = 0.0;
   else
        k1 = 0.0;
		k2 = 0.0;
		k3 = 0.0;
		k4 = 0.0;
		k5 = 0.0;
		k6 = 0.0;
		k7 = 0.0;
		k8 = 0.0;
    end
    
Vas = (ro*c^2)*(Seff^2)/(k0-Kmb);   % Vas in cubic meters  
    
% Mechanical losses:
		% rm0 = 14.5;                 % Rms for contant mech losses
        rm0=rm;          % (rab)
    
 % Voice coil inductance (Assumes Henries):						
Lcond = 1;                          % Flag of linear and nonlinear inductance
		% L0 = 1.6736*1e-3;           % Enter Klippel value mH * 1e-3
        L0 = Le*1000;                % (rab) millihenries! 
	if Lcond == 1
		L1 = 0.011653;              % Enter Klippel value as is
		L2 = 0.0032495*1e3;         % Enter Klippel value * 1e3
		L3 = -4.49E-05*1e6;         % Enter Klippel value * 1e6
		L4 = -6.06E-06*1e9;         % etc...
		L5 = 1.13E-07*1e12;
		L6 = 9.90E-09*1e15;
		L7 = -1.53E-10*1e18;
		L8 = -1.01E-11*1e21;
    else  
     	L1 = 0.0;
		L2 = 0.0;
		L3 = 0.0;
		L4 = 0.0;
		L5 = 0.0;
		L6 = 0.0;
		L7 = 0.0;
		L8 = 0.0;
    end
    

%%
% Start of Pedersen model initiialization &&&&&&&&
% Cmoff(x) section - extra section for dealing with drift of Cm with time
AlpaCmLoss = 1;     %gain 1
CCm = 1;    % part of gain2
MCm = 1;    % part of gain2

% Cmoffset = 0;    
Cmoffset = cm;       % (rab) CRITICAL Cm offset1
KCmHeatLoss = 1;     %Temperature varying Cm

% nonlinear compliance&
[Cdx] = [0 0 0 0 1/k4 1/k3 1/k2 1/k1 1/k0];

% nonlinear BL
[Blx] = [b8 b7 b6 b5 b4 b3 b2 b1 b0];

% nonlinear Le
[Lex] = [L8 L7 L6 L5 L4 L3 L2 L1 L0];

% mechanical losses
Rm = rm0;                     % Rms for constant mechanical losses


%%

%%%%%%%%%%%%%%%%%%%%%%% END OF USER INPUT SECTION %%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
