 function [lpf_ellip,LCvalues,Tf]=ellip_lpf(LCvec,freq,Fc,Zo,Ql)
% LC elliptic filter design
% LCvector of values
% Series resonant traps for transmission zeros

% Ql = 100;   % nominal inductor Q at 100e6;
qf = 2*pi*100e6/Ql;
wn = 2*pi*Fc;
% compute actual component values given Zo and Fc 
L1 = LCvec(1)*Zo/wn;    R1 = qf*L1;
L2 = LCvec(2)*Zo/wn;    R2 = qf*L2;
C2 = LCvec(3)/(Zo*wn);
L3 = LCvec(4)*Zo/wn;    R3 = qf*L3;
L4 = LCvec(5)*Zo/wn;    R4 = qf*L4;
C4 = LCvec(6)/(Zo*wn);
L5 = LCvec(7)*Zo/wn;    R5 = qf*L5;

Zl = Zo*LCvec(8);

LCvalues = [L1,L2,C2,L3,L4,C4,L5,Zl];

% construct circuit and test freq response
hl1   = rfckt.seriesrlc('R',R1,'L',L1,'C',inf);

% This creates a series RLC (yup) that is in shunt with the transmission
% path  The construction is NOT OBVIOUS! 
hl2     = rfckt.shuntrlc('R',inf,'L',L2,'C',0);
hr2     = rfckt.shuntrlc('R',R2,'L',inf,'C',0);
hc2     = rfckt.shuntrlc('R',inf,'L',inf,'C',C2);
hl2r2c2 = rfckt.series('Ckts',{hl2,hr2,hc2});

hl3 = rfckt.seriesrlc('R',R1,'L',L3,'C',inf);

% Another series RLC in shunt 
hl4     = rfckt.shuntrlc('R',inf,'L',L4,'C',0);
hr4     = rfckt.shuntrlc('R',R4,'L',inf,'C',0);
hc4     = rfckt.shuntrlc('R',inf,'L',inf,'C',C4);
hl4r4c4 = rfckt.series('Ckts',{hl4,hr4,hc4});

hl5   = rfckt.seriesrlc('R',R5,'L',L5,'C',inf);

lpf_ellip = rfckt.cascade('Ckts',{hl1,hl2r2c2,hl3,hl4r4c4,hl5}); 

analyze(lpf_ellip,freq);
Zs = 50;
Tf = s2tf(lpf_ellip.AnalyzedResult.S_Parameters, Zo, Zs, Zl,1);


