%% Fit a ratio of polynomials in the Laplace variable s to transfer function measurement data                                                                                                    
% Copyright 2012-2015 The MathWorks, Inc.
% Dick Benson

sp = 4; % Start point for plot and fit to discard DC  
% TF is the measured plant transfer function from the simulation 
f=TF(sp:end,1);      % frequency vector 
xfer = TF(sp:end,2); % transfer function
w=2*pi*f;
L=length(f);   
iter=1;
[num,den]=invfreqs(xfer,w,2,2,[],iter); % invfreqs is in the signal processing TB
resp = freqs(num,den,w);                % freq response of fit results                                                                                                                                          
%% plot fit result and the measured transfer function for a check on the fit                                                                                                                                          
subplot(2,1,1);                                                                                                                                        
plot(f,db(resp),f,20*log10(abs(xfer)));
title('Magnitude vs Freq'); xlabel('Hz'); ylabel('dB');legend('fit','meas');             
subplot(2,1,2);                                                                                                                                        
plot(f,(180/pi)*angle(resp),f,(180/pi)*angle(xfer));
title('Phase vs Freq'); xlabel('Hz'); ylabel('Degrees');legend('fit','meas');

%% create an LTI "object"
G=tf(num,den); 
% G = balred(Gx,2); % reduce to a second order system if need be. 
ltiview('step',G);
ltiview('pzmap',G);
save ps_plant_model G Fs_ADC TF;  
clc
